<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Upload Image</title>
</head>

<body>
    <div>
        <div id="inputImage">
            <div id="dropArea">
                <div id="dropImage" ondrop="dropImage(event)" ondragover="event.preventDefault()"
                    onclick="document.getElementById('selectImage').click();">
                    <input style="display: none;" type="file" accept="image/jpeg" id="selectImage"
                        onchange="dropImage(event)" />
                    <h4>Select or Drop Image<br /><small>(jpg / jpeg upto 2mb)</small></h4>
                </div>
                <div class="grid-row">
                    <div>
                        <h4>Selected Image</h4>
                        <img id="dropImagePreview">
                    </div>
                    <div id="outputImage">
                        <h4><span id="loader">prediction</span></h4>
                        <img id="outputImagePreview">
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script>
        const loader = document.getElementById('loader');
        const outputPreview = document.getElementById('outputImagePreview');
        const dropImage = async (e) => {
            e.preventDefault();
            var data = e.dataTransfer ? e.dataTransfer.files : e.target.files;
            var image = data[0];
            if (image.type == 'image/jpeg' && image.size < 2000000) {
                var selectedImage = await readImage(image);
                document.getElementById('dropImagePreview').src = selectedImage;
                if (selectedImage) {
                    detect(image);
                }
            } else {
                alert('Unsupported file. Please upload a .jpg or .jpeg file less than 2mb.')
            }
        }

        const readImage = (imageData) => {
            return new Promise((resolve, reject) => {
                const fileReader = new FileReader();
                fileReader.readAsDataURL(imageData);
                fileReader.addEventListener("load", () => {
                    resolve(fileReader.result);
                });
            });
        }

        const detect = async (image) => {
            const url = '/predict';
            const formData = new FormData();
            formData.append('image', image);
            loader.innerHTML = 'predicting please wait...';
            outputPreview.src = '';
            let response = await fetch(url, {
                method: 'POST',
                body: formData
            });
            try {
                let res = await response.json();
                outputPreview.src = res.image;
                loader.innerHTML = 'prediction';
            } catch (error) {
                alert(response.status);
            }
        }

    </script>
    <style>
        body {
            font-family: Arial, Helvetica, sans-serif;
        }

        #dropArea {
            width: 100%;
            min-height: 50px;
            text-align: center;
        }

        #dropImage {
            border: dashed 1px #eeaaee;
            padding: 30px;
        }

        #dropArea img,
        #outputImagePreview {
            width: 80%;
            height: auto;
            margin: 0 auto;
        }

        #selectImageFakeButton {
            background: blue;
            padding: 5px;
            border-radius: 5px;
            cursor: pointer;
            color: white;
            border: none;
            box-shadow: 0px 2px 10px rgba(0, 0, 0, 0.2);
        }

        .grid-row {
            display: grid;
            grid-template-columns: repeat(2, 1fr);
            grid-gap: 0.5rem;
        }

        @media only screen and (max-width: 600px) {

            #dropArea img,
            #outputImagePreview {
                width: 90%;
            }

            .grid-row {
                grid-template-columns: repeat(1, 1fr);
                order: -1;
            }
        }
    </style>
</body>

</html>